using DigitalOps.Authority.Services;
using Microsoft.Extensions.DependencyInjection;
using OpenHarbor.CQRS.Abstractions.Security;
using PoweredSoft.Module.Abstractions;

namespace DigitalOps.Authority;

public class AuthorityModule : IModule
{
  public IServiceCollection ConfigureServices(IServiceCollection services)
  {
    services
      .AddScoped<IQueryAuthorizationService, CQAuthorizationService>();
    
    services
      .AddScoped<ICommandAuthorizationService, CQAuthorizationService>();
    
    services.AddScoped<UserIdentityService>();
    return services;
  }
}