using DigitalOps.CQRS.Queries.Client;
using DigitalOps.CQRS.Queries.Health;
using DigitalOps.CQRS.Queries.Organization;
using DigitalOps.CQRS.Queries.Project;
using Microsoft.Extensions.DependencyInjection;
using PoweredSoft.Module.Abstractions;

namespace DigitalOps.CQRS;

public class QueryModule : IModule
{
  public IServiceCollection ConfigureServices(IServiceCollection services)
  {
    services.AddHealthQueries();

    services.AddModule<RegisterOrganizationQueriesModule>();
    services.AddModule<RegisterClientQueriesModule>();
    services.AddModule<RegisterProjectQueriesModule>();
    
    return services;
  }
}