using Microsoft.Extensions.DependencyInjection;
using OpenHarbor.CQRS.DynamicQuery.Abstractions;
using PoweredSoft.Data.Core;
using PoweredSoft.Module.Abstractions;

namespace DigitalOps.Dal;

public class DalModule : IModule
{
  public IServiceCollection ConfigureServices(IServiceCollection services)
  {
    return services.AddSingleton<IAsyncQueryableHandlerService, InMemoryQueryableHandlerService>()
      .AddTransient(typeof(IQueryableProvider<>), typeof(DefaultQueryableProvider<>));
  }
}